#include <Procesador_jni.h>

#include <jni.h>
#include <opencv2/core/core.hpp>
#include <opencv2/core/mat.hpp>
#include <opencv2/core/operations.hpp>
#include <opencv2/core/types_c.h>
#include <opencv2/imgproc/imgproc.hpp>

#define LOG_TAG "FaceDetection/Procesador"
#define LOGD(...) ((void)__android_log_print(ANDROID_LOG_DEBUG, LOG_TAG, __VA_ARGS__))

using namespace std;
using namespace cv;

JNIEXPORT void JNICALL Java_com_example_gasullajproyectomaster_Procesador_nativeReflejaHoriz
  (JNIEnv * jenv, jclass, jlong inputImage, jlong outputImage)
{
	int matRows = ((Mat*)inputImage)->rows;
	int matCols = ((Mat*)inputImage)->cols;
	cv::Mat map_x(matRows, matCols, CV_32FC1);
	cv::Mat map_y(matRows, matCols, CV_32FC1);


	for(int i = 0; i < ((Mat*)inputImage)->rows; i++ ) {
		for (int j = 0; j < ((Mat*)inputImage)->cols; j++ ) {
			map_x.at<float>(i, j) = ((Mat*)inputImage)->cols - 1 - j;
	        map_y.at<float>(i, j) = i;
	    }
	}

	remap(*((Mat*)inputImage), *((Mat*)outputImage), map_x, map_y, CV_INTER_LINEAR, BORDER_CONSTANT, Scalar(0, 0, 0));
	map_x.release();
	map_y.release();

}

