package com.example.gasullajproyectomaster;

import java.io.FileNotFoundException;

import android.content.ContentResolver;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.net.Uri;
import android.widget.Toast;

public class AjustesDrawables {
	
	// Ajustamos el tamao del drawable indicado
	public static Drawable ajustarDrawable(Context contexto, int resId, double factorAjuste, int mainWidth, int mainHeight) {
		// Obtenemos la Uri para el recurso indicado
		Uri uri = Uri.parse(ContentResolver.SCHEME_ANDROID_RESOURCE + "://"
				+ contexto.getResources().getResourcePackageName(resId) + '/'
				+ contexto.getResources().getResourceTypeName(resId) + '/'
				+ contexto.getResources().getResourceEntryName(resId));
		
		// Ajustamos el tamao del bitmap
		Bitmap bitmap = reduceBitmap(contexto, uri.toString(),
				(int) (mainWidth * factorAjuste),
				(int) (mainHeight * factorAjuste));
		
		// Retornamos el drawable obtenido del bitmap ajustado  
		return new BitmapDrawable(contexto.getResources(), bitmap);
	}		
	    
	// Utilizado para ajustar el tamao del bitmap en funcin
    // del tamao del contenedor (variable dependiendo del terminal)
    private static Bitmap reduceBitmap(Context contexto, String uri, int maxAncho, int maxAlto) {
        try {
            final BitmapFactory.Options options = new BitmapFactory.Options();
            options.inJustDecodeBounds = true;
            BitmapFactory.decodeStream(contexto.getContentResolver()
                    .openInputStream(Uri.parse(uri)), null, options);            
            options.inSampleSize = (int) Math.max(          
                    Math.ceil(options.outWidth / maxAncho),
                    Math.ceil(options.outHeight / maxAlto));			            
            options.inJustDecodeBounds = false;
            return BitmapFactory.decodeStream(contexto.getContentResolver()
                    .openInputStream(Uri.parse(uri)), null, options);
        } catch (FileNotFoundException e) {
            Toast.makeText(contexto, "Fichero/recurso no encontrado",
                    Toast.LENGTH_LONG).show();
            e.printStackTrace();
            return null;
        }
    }

}
